
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "csi.h"
#include "rif.h"

extern void	Error(char *msg);

#define RL_T	Cell
#include "rl.h"

#define LIM	(size_t)((Cell)~0)
#define LEN	1024

int	main(int argc,char **argv)
{
	char		**path;
	int		Nx,Ny,Nz,y,z,nx,ny,x;
	unsigned long	Vt=0,Vr=0,Vs=0,F=0;
	Cell		lut[LIM+1],**A,**B,**C;

	if (argc!=3 && argc!=4)
	    Error("usage : si_vfc directory nameFile {rangeList}");

	path=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);
{
	unsigned long	pv;
	char		str[LEN],rl[LEN];

	if (argc==3) {
	    lut[0]=0; for (pv=1; pv<=LIM; pv++) lut[pv]=1;

	    while (fgets(str,LEN,stdin)!=NULL && str[strlen(str)-1]=='\n') {
		switch(sscanf(str,"%s %lu",rl,&pv)) {
		    case  1: pv=0; break;
		    case  2: if (pv>LIM) Error("bad pixel value."); break;
		    default: continue;
		}
		RangeList(rl,LIM,lut,(Cell)pv);
	    }
	}
	else {
	    for (pv=0; pv<=LIM; pv++) lut[pv]=0;

	    RangeList(argv[3],LIM,lut,1);
	}
}
	if ((A=(Cell **)malloc(sizeof(Cell *)*(Ny+2)))==NULL ||
	    (B=(Cell **)malloc(sizeof(Cell *)*(Ny+2)))==NULL ||
	    (*A=(Cell *)calloc((size_t)(Ny+2)*(Nx+2),sizeof(Cell)))==NULL ||
            (*B=(Cell *)calloc((size_t)(Ny+2)*(Nx+2),sizeof(Cell)))==NULL)
	    Error("memory allocation error.");

	++A; ++A[-1]; ++B; ++B[-1];
	for (y=0; y<=Ny; y++) {
	    A[y]=A[y-1]+Nx+2; B[y]=B[y-1]+Nx+2;
	}
	for (z=0; z<=Nz; z++) {
	    C=A; A=B; B=C;

	    if (z<Nz) {
		ReadImageFile(path[z],&nx,&ny,NULL,&C,NULL); free(path[z]);

		for (y=0; y<Ny; y++) {
		    for (x=0; x<Nx; x++) B[y][x]=lut[(x<nx && y<ny)?C[y][x]:0];

		    if (y<ny) free(C[y]);
		}
		free(C);
	    }
	    else {
		free(path);

		for (y=0; y<Ny; y++)
		for (x=0; x<Nx; x++) B[y][x]=0;
	    }
	    for (y=0; y<=Ny; y++)
	    for (x=0; x<=Nx; x++)
{
	Cell	ANW=A[y-1][x-1],ANE=A[y-1][x],ASW=A[y][x-1],ASE=A[y][x],
		BNW=B[y-1][x-1],BNE=B[y-1][x],BSW=B[y][x-1],BSE=B[y][x];
	int	anw=ANW!=0,ane=ANE!=0,asw=ASW!=0,ase=ASE!=0,
		bnw=BNW!=0,bne=BNE!=0,bsw=BSW!=0,bse=BSE!=0,
		fx=(anw!=ane)+(asw!=ase)+(bnw!=bne)+(bsw!=bse),
		fy=(anw!=asw)+(ane!=ase)+(bnw!=bsw)+(bne!=bse),
		fz=(anw!=bnw)+(ane!=bne)+(asw!=bsw)+(ase!=bse),f=fx+fy+fz;

	if (f) {
	    if ((fx || ANW!=ANE || ASW!=ASE || BNW!=BNE || BSW!=BSE) &&
		(fy || ANW!=ASW || ANE!=ASE || BNW!=BSW || BNE!=BSE) &&
		(fz || ANW!=BNW || ANE!=BNE || ASW!=BSW || ASE!=BSE))
		++Vt;
	    else
		if (f==8) ++Vr;

	    ++Vs; F+=f;
	}
}
	}
	free(A[-1]-1); free(A-1); free(B[-1]-1); free(B-1);

	F/=4;
	(void)printf("%lu\t%lu\t%lu\n%lu\t%lu\n",Vs,Vr,F,Vt,2*(Vt-Vr-Vs+F));

	return 0;
}
