
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void	Error(char *msg)
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

#define BYTE	unsigned char

static void	Normal(BYTE *byte,FILE *file)
{
	(void)fwrite(byte,(size_t)4,(size_t)3,file);
}

static void	Reverse(BYTE *byte,FILE *file)
{
	int	j,k;

	for (j=0; j<3; j++) {
	    for (k=3; k>=0; k--) (void)fputc(byte[k],file); byte+=4;
	}
}

#define LEN	1024
#define WORD	unsigned int

int	main(int argc,char **argv)
{
	int	i=127;
	char	str[LEN],*c=(char *)&i;
	void	(*Fwrite)()=(*c==i)?Normal:Reverse;
	WORD	Nv,Nf,v,f,U[3],r,g,b,R=255,G=255,B=255;
	FILE	*V,*F,*ZCP;
	float	W[3];

	if (argc!=2 && argc!=4 && argc!=5 && argc!=7)
	    Error("usage : vf2zcp {v.txt f.txt} ZCP {R G B}");

	if ((argc==5 || argc==7) &&
	    (sscanf(argv[argc-3],"%u",&R)!=1 || R>=256 ||
	     sscanf(argv[argc-2],"%u",&G)!=1 || G>=256 ||
	     sscanf(argv[argc-1],"%u",&B)!=1 || B>=256))
	    Error("bad default R, G and/or B values for faces.");

	if (argc==2 || argc==5) {
	    V=F=stdin;
	    if (fgets(str,LEN,stdin)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%u %u",&Nv,&Nf)!=2 || Nv==0 || Nf==0)
		Error("bad number of vertices and/or faces.");

	    i=1;
	}
	else {
	    if ((V=fopen(argv[1],"r"))==NULL) Error("vertex file not found.");

	    if (fgets(str,LEN,V)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%u",&Nv)!=1 || Nv==0)
		Error("bad number of vertices.");

	    if ((F=fopen(argv[2],"r"))==NULL) Error("face file not found.");

	    if (fgets(str,LEN,F)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%u",&Nf)!=1 || Nf==0)
		Error("bad number of faces.");

	    i=3;
	}
	if (argv[i][0]=='-')
	    ZCP=stdout;
	else
	    if ((ZCP=fopen(argv[i],"wb"))==NULL) Error("ZCP file not open.");

	(void)fprintf(ZCP,"ply\n"
			  "format binary_little_endian 1.0\n"
			  "element vertex %u\n"
			  "property float x\n"
			  "property float y\n"
			  "property float z\n"
			  "element face %u\n"
			  "property uchar red\n"
			  "property uchar green\n"
			  "property uchar blue\n"
			  "property list uchar int vertex_indices\n"
			  "end_header\n",Nv,Nf);

	for (v=0; v<Nv; v++) {
	    if (fgets(str,LEN,V)==NULL || str[strlen(str)-1]!='\n' ||
		sscanf(str,"%f %f %f",W+0,W+1,W+2)!=3) Error("bad vertex.");

	    (*Fwrite)((BYTE *)W,ZCP);
	}
	if (V!=stdin) (void)fclose(V);

	for (f=0; f<Nf; f++) {
	    if ((i=fgets(str,LEN,F)!=NULL)!=0 && str[strlen(str)-1]=='\n')
		switch(sscanf(str,"%u %u %u %u %u %u",U+0,U+1,U+2,&r,&g,&b)) {
		    case  3: r=R; g=G; b=B; break;
		    case  4: if ((i=r<256)!=0) g=b=r; break;
		    case  6: i=r<256 && g<256 && b<256; break;
		    default: i=0; break;
		}

	    if (!i || U[0]>=Nv || U[1]>=Nv || U[2]>=Nv) Error("bad face.");

	    (void)fputc(r,ZCP); (void)fputc(g,ZCP); (void)fputc(b,ZCP);
	    (void)fputc(3,ZCP); (*Fwrite)((BYTE *)U,ZCP);
	}
	if (F!=stdin) (void)fclose(F);

	if (ZCP!=stdout) (void)fclose(ZCP);

	return 0;
}
